/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.104 Revision 1.139
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.104 2010/10/25 11:54:19 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.139 2011/10/15 20:58:08 phajdan.jr Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The python eclass contains miscellaneous, useful functions for Python packages. 10# The python eclass contains miscellaneous, useful functions for Python packages.
11 11
12inherit multilib 12inherit multilib
13 13
14if ! has "${EAPI:-0}" 0 1 2 3; then 14if ! has "${EAPI:-0}" 0 1 2 3 4; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 15 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 16fi
17 17
18_CPYTHON2_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_CPYTHON3_SUPPORTED_ABIS=(3.0 3.1 3.2) 19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2)
20_JYTHON_SUPPORTED_ABIS=(2.5-jython) 20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
21_PYTHON_SUPPORTED_ABIS=(${_CPYTHON2_SUPPORTED_ABIS[@]} ${_CPYTHON3_SUPPORTED_ABIS[@]} ${_JYTHON_SUPPORTED_ABIS[@]}) 21_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.5)
22_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]})
22 23
23# ================================================================================================ 24# ================================================================================================
24# ===================================== HANDLING OF METADATA ===================================== 25# ===================================== HANDLING OF METADATA =====================================
25# ================================================================================================ 26# ================================================================================================
26 27
27_python_set_IUSE() { 28_PYTHON_ABI_PATTERN_REGEX="([[:alnum:]]|\.|-|\*|\[|\])+"
28 local PYTHON_ABI restricted_ABI restricted_ABIs support_ABI
29 29
30 _PYTHON_ABIS_USE_FLAGS="" 30_python_check_python_abi_matching() {
31 restricted_ABIs="${RESTRICT_PYTHON_ABIS// /$'\n'}" 31 local pattern patterns patterns_list="0" PYTHON_ABI
32 32
33 for PYTHON_ABI in "${_PYTHON_SUPPORTED_ABIS[@]}"; do 33 while (($#)); do
34 support_ABI="1" 34 case "$1" in
35 while read restricted_ABI; do 35 --patterns-list)
36 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 36 patterns_list="1"
37 support_ABI="0" 37 ;;
38 --)
39 shift
38 break 40 break
39 fi 41 ;;
40 done <<< "${restricted_ABIs}" 42 -*)
41 [[ "${support_ABI}" == "1" ]] && _PYTHON_ABIS_USE_FLAGS+="${_PYTHON_ABIS_USE_FLAGS:+ }python_abis_${PYTHON_ABI}" 43 die "${FUNCNAME}(): Unrecognized option '$1'"
44 ;;
45 *)
46 break
47 ;;
48 esac
49 shift
42 done 50 done
43 51
44 IUSE="${_PYTHON_ABIS_USE_FLAGS}" 52 if [[ "$#" -ne 2 ]]; then
45} 53 die "${FUNCNAME}() requires 2 arguments"
46
47if ! has "${EAPI:-0}" 0 1 2 3 && [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
48 _python_set_IUSE
49fi 54 fi
50unset -f _python_set_IUSE 55
56 PYTHON_ABI="$1"
57
58 if [[ "${patterns_list}" == "0" ]]; then
59 pattern="$2"
60
61 if [[ "${pattern}" == *"-cpython" ]]; then
62 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]]
63 elif [[ "${pattern}" == *"-jython" ]]; then
64 [[ "${PYTHON_ABI}" == ${pattern} ]]
65 elif [[ "${pattern}" == *"-pypy-"* ]]; then
66 [[ "${PYTHON_ABI}" == ${pattern} ]]
67 else
68 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
69 [[ "${PYTHON_ABI}" == ${pattern} ]]
70 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
71 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]]
72 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
73 [[ "${PYTHON_ABI%-pypy-*}" == ${pattern} ]]
74 else
75 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'"
76 fi
77 fi
78 else
79 patterns="${2// /$'\n'}"
80
81 while read pattern; do
82 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
83 return 0
84 fi
85 done <<< "${patterns}"
86
87 return 1
88 fi
89}
90
91_python_package_supporting_installation_for_multiple_python_abis() {
92 if has "${EAPI:-0}" 0 1 2 3 4; then
93 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
94 return 0
95 else
96 return 1
97 fi
98 else
99 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
100 fi
101}
51 102
52# @ECLASS-VARIABLE: PYTHON_DEPEND 103# @ECLASS-VARIABLE: PYTHON_DEPEND
53# @DESCRIPTION: 104# @DESCRIPTION:
54# Specification of dependency on dev-lang/python. 105# Specification of dependency on dev-lang/python.
55# Syntax: 106# Syntax:
90 fi 141 fi
91 fi 142 fi
92 143
93 if [[ "${major_version}" == "2" ]]; then 144 if [[ "${major_version}" == "2" ]]; then
94 python2="1" 145 python2="1"
95 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}") 146 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
96 python2_minimal_version="${minimal_version}" 147 python2_minimal_version="${minimal_version}"
97 python2_maximal_version="${maximal_version}" 148 python2_maximal_version="${maximal_version}"
98 elif [[ "${major_version}" == "3" ]]; then 149 elif [[ "${major_version}" == "3" ]]; then
99 python3="1" 150 python3="1"
100 python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}") 151 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
101 python3_minimal_version="${minimal_version}" 152 python3_minimal_version="${minimal_version}"
102 python3_maximal_version="${maximal_version}" 153 python3_maximal_version="${maximal_version}"
103 else 154 else
104 python_all="1" 155 python_all="1"
105 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}") 156 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
106 python_minimal_version="${minimal_version}" 157 python_minimal_version="${minimal_version}"
107 python_maximal_version="${maximal_version}" 158 python_maximal_version="${maximal_version}"
108 fi 159 fi
109 160
110 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then 161 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then
138 189
139 if [[ "${python_all}" == "1" ]]; then 190 if [[ "${python_all}" == "1" ]]; then
140 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then 191 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then
141 _PYTHON_ATOMS+=("dev-lang/python") 192 _PYTHON_ATOMS+=("dev-lang/python")
142 else 193 else
143 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}") 194 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
144 python_minimal_version="${python_minimal_version:-${python_versions[0]}}" 195 python_minimal_version="${python_minimal_version:-${python_versions[0]}}"
145 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 196 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
146 _append_accepted_versions_range 197 _append_accepted_versions_range
147 fi 198 fi
148 else 199 else
149 if [[ "${python3}" == "1" ]]; then 200 if [[ "${python3}" == "1" ]]; then
150 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then 201 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then
151 _PYTHON_ATOMS+=("=dev-lang/python-3*") 202 _PYTHON_ATOMS+=("=dev-lang/python-3*")
152 else 203 else
153 python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}") 204 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
154 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}" 205 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}"
155 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 206 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
156 _append_accepted_versions_range 207 _append_accepted_versions_range
157 fi 208 fi
158 fi 209 fi
159 if [[ "${python2}" == "1" ]]; then 210 if [[ "${python2}" == "1" ]]; then
160 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then 211 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then
161 _PYTHON_ATOMS+=("=dev-lang/python-2*") 212 _PYTHON_ATOMS+=("=dev-lang/python-2*")
162 else 213 else
163 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}") 214 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
164 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}" 215 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}"
165 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 216 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
166 _append_accepted_versions_range 217 _append_accepted_versions_range
167 fi 218 fi
168 fi 219 fi
237 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY 288 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
238fi 289fi
239 290
240unset _PYTHON_ATOMS 291unset _PYTHON_ATOMS
241 292
242# @FUNCTION: python_abi_depend
243# @USAGE: [-e|--exclude-ABIs Python_ABIs] [-i|--include-ABIs Python_ABIs] [--] <dependency_atom> [dependency_atoms]
244# @DESCRIPTION:
245# Print dependency atoms with USE dependencies for Python ABIs added.
246# If --exclude-ABIs option is specified, then Python ABIs matching its argument are not used.
247# If --include-ABIs option is specified, then only Python ABIs matching its argument are used.
248# --exclude-ABIs and --include-ABIs options cannot be specified simultaneously.
249python_abi_depend() {
250 local atom atom_index atoms=() exclude_ABIs="0" excluded_ABI excluded_ABIs include_ABIs="0" included_ABI included_ABIs support_ABI USE_dependencies USE_flag USE_flag_index USE_flags=()
251
252 if has "${EAPI:-0}" 0 1 2 3; then
253 die "${FUNCNAME}() cannot be used in this EAPI"
254 fi
255
256 if [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then
257 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
258 fi
259
260 while (($#)); do
261 case "$1" in
262 -e|--exclude-ABIs)
263 exclude_ABIs="1"
264 excluded_ABIs="${2// /$'\n'}"
265 shift
266 ;;
267 -i|--include-ABIs)
268 include_ABIs="1"
269 included_ABIs="${2// /$'\n'}"
270 shift
271 ;;
272 --)
273 shift
274 break
275 ;;
276 -*)
277 die "${FUNCNAME}(): Unrecognized option '$1'"
278 ;;
279 *)
280 break
281 ;;
282 esac
283 shift
284 done
285
286 if [[ "${exclude_ABIs}" == "1" && "${include_ABIs}" == "1" ]]; then
287 die "${FUNCNAME}(): '--exclude-ABIs' and '--include-ABIs' options cannot be specified simultaneously"
288 fi
289
290 if [[ "$#" -eq 0 ]]; then
291 die "${FUNCNAME}(): Missing dependency atoms"
292 fi
293
294 atoms=("$@")
295
296 if [[ "${exclude_ABIs}" == "0" && "${include_ABIs}" == "0" ]]; then
297 USE_dependencies="$(printf ",%s?" ${_PYTHON_ABIS_USE_FLAGS})"
298 USE_dependencies="${USE_dependencies#,}"
299
300 for atom_index in "${!atoms[@]}"; do
301 atom="${atoms[${atom_index}]}"
302
303 if [[ "${atom}" == *"["*"]" ]]; then
304 echo -n "${atom%]},"
305 else
306 echo -n "${atom}["
307 fi
308 echo -n "${USE_dependencies}]"
309
310 if [[ "${atom_index}" -ne $((${#atoms[@]} - 1)) ]]; then
311 echo -n " "
312 fi
313 done
314 else
315 if [[ "${exclude_ABIs}" == "1" ]]; then
316 for USE_flag in ${_PYTHON_ABIS_USE_FLAGS}; do
317 while read excluded_ABI; do
318 support_ABI="1"
319 if [[ "${USE_flag}" == python_abis_${excluded_ABI} ]]; then
320 support_ABI="0"
321 break
322 fi
323 done <<< "${excluded_ABIs}"
324 [[ "${support_ABI}" == "1" ]] && USE_flags+=("${USE_flag}")
325 done
326 elif [[ "${include_ABIs}" == "1" ]]; then
327 for USE_flag in ${_PYTHON_ABIS_USE_FLAGS}; do
328 while read included_ABI; do
329 support_ABI="0"
330 if [[ "${USE_flag}" == python_abis_${included_ABI} ]]; then
331 support_ABI="1"
332 break
333 fi
334 done <<< "${included_ABIs}"
335 [[ "${support_ABI}" == "1" ]] && USE_flags+=("${USE_flag}")
336 done
337 else
338 die "${FUNCNAME}(): Internal error"
339 fi
340
341 for USE_flag_index in "${!USE_flags[@]}"; do
342 USE_flag="${USE_flags[${USE_flag_index}]}"
343 USE_dependencies="${USE_flag}"
344
345 echo -n "${USE_flag}? ( "
346
347 for atom_index in "${!atoms[@]}"; do
348 atom="${atoms[${atom_index}]}"
349
350 if [[ "${atom}" == *"["*"]" ]]; then
351 echo -n "${atom%]},"
352 else
353 echo -n "${atom}["
354 fi
355 echo -n "${USE_dependencies}]"
356
357 if [[ "${atom_index}" -ne $((${#atoms[@]} - 1)) ]]; then
358 echo -n " "
359 fi
360 done
361
362 echo -n " )"
363
364 if [[ "${USE_flag_index}" -ne $((${#USE_flags[@]} - 1)) ]]; then
365 echo -n " "
366 fi
367 done
368 fi
369}
370
371# ================================================================================================ 293# ================================================================================================
372# =================================== MISCELLANEOUS FUNCTIONS ==================================== 294# =================================== MISCELLANEOUS FUNCTIONS ====================================
373# ================================================================================================ 295# ================================================================================================
374 296
375_python_implementation() { 297_python_implementation() {
376 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then 298 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
377 return 0 299 return 0
378 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then 300 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
379 return 0 301 return 0
302 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
303 return 0
380 else 304 else
381 return 1 305 return 1
382 fi
383}
384
385_python_package_supporting_installation_for_multiple_python_abis() {
386 if [[ "${EBUILD_PHASE}" == "depend" ]]; then
387 die "${FUNCNAME}() cannot be used in global scope"
388 fi
389
390 if has "${EAPI:-0}" 0 1 2 3 4; then
391 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
392 return 0
393 else
394 return 1
395 fi
396 else
397 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
398 fi 306 fi
399} 307}
400 308
401_python_abi-specific_local_scope() { 309_python_abi-specific_local_scope() {
402 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]] 310 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
492# @DESCRIPTION: 400# @DESCRIPTION:
493# Perform sanity checks and initialize environment. 401# Perform sanity checks and initialize environment.
494# 402#
495# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable 403# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable
496# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4. 404# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4.
497#
498# This function can be used only in pkg_setup() phase.
499python_pkg_setup() { 405python_pkg_setup() {
500 # Check if phase is pkg_setup(). 406 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
501 [[ "${EBUILD_PHASE}" != "setup" ]] && die "${FUNCNAME}() can be used only in pkg_setup() phase" 407 die "${FUNCNAME}() can be used only in pkg_setup() phase"
408 fi
502 409
503 if [[ "$#" -ne 0 ]]; then 410 if [[ "$#" -ne 0 ]]; then
504 die "${FUNCNAME}() does not accept arguments" 411 die "${FUNCNAME}() does not accept arguments"
505 fi 412 fi
413
414 export JYTHON_SYSTEM_CACHEDIR="1"
415 addwrite "${EPREFIX}/var/cache/jython"
506 416
507 if _python_package_supporting_installation_for_multiple_python_abis; then 417 if _python_package_supporting_installation_for_multiple_python_abis; then
508 _python_calculate_PYTHON_ABIS 418 _python_calculate_PYTHON_ABIS
509 export EPYTHON="$(PYTHON -f)" 419 export EPYTHON="$(PYTHON -f)"
510 else 420 else
557 467
558if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then 468if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
559 EXPORT_FUNCTIONS pkg_setup 469 EXPORT_FUNCTIONS pkg_setup
560fi 470fi
561 471
472_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)'
473
562# @FUNCTION: python_convert_shebangs 474# @FUNCTION: python_convert_shebangs
563# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories] 475# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
564# @DESCRIPTION: 476# @DESCRIPTION:
565# Convert shebangs in specified files. Directories can be specified only with --recursive option. 477# Convert shebangs in specified files. Directories can be specified only with --recursive option.
566python_convert_shebangs() { 478python_convert_shebangs() {
567 _python_check_python_pkg_setup_execution 479 _python_check_python_pkg_setup_execution
568 480
569 local argument file files=() only_executables="0" python_version quiet="0" recursive="0" 481 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0"
570 482
571 while (($#)); do 483 while (($#)); do
572 case "$1" in 484 case "$1" in
573 -r|--recursive) 485 -r|--recursive)
574 recursive="1" 486 recursive="1"
597 die "${FUNCNAME}(): Missing Python version and files or directories" 509 die "${FUNCNAME}(): Missing Python version and files or directories"
598 elif [[ "$#" -eq 1 ]]; then 510 elif [[ "$#" -eq 1 ]]; then
599 die "${FUNCNAME}(): Missing files or directories" 511 die "${FUNCNAME}(): Missing files or directories"
600 fi 512 fi
601 513
602 python_version="$1" 514 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
515 python_interpreter="$(PYTHON "$1")"
516 else
517 python_interpreter="python$1"
518 fi
603 shift 519 shift
604 520
605 for argument in "$@"; do 521 for argument in "$@"; do
606 if [[ ! -e "${argument}" ]]; then 522 if [[ ! -e "${argument}" ]]; then
607 die "${FUNCNAME}(): '${argument}' does not exist" 523 die "${FUNCNAME}(): '${argument}' does not exist"
622 538
623 for file in "${files[@]}"; do 539 for file in "${files[@]}"; do
624 file="${file#./}" 540 file="${file#./}"
625 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue 541 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
626 542
627 if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then 543 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
628 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue 544 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
629 545
630 if [[ "${quiet}" == "0" ]]; then 546 if [[ "${quiet}" == "0" ]]; then
631 einfo "Converting shebang in '${file}'" 547 einfo "Converting shebang in '${file}'"
632 fi 548 fi
633 549
634 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed" 550 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
635
636 # Delete potential whitespace after "#!".
637 sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed"
638 fi 551 fi
639 done 552 done
640} 553}
641 554
642# @FUNCTION: python_clean_installation_image 555# @FUNCTION: python_clean_installation_image
643# @USAGE: [-q|--quiet] 556# @USAGE: [-q|--quiet]
644# @DESCRIPTION: 557# @DESCRIPTION:
645# Delete needless files in installation image. 558# Delete needless files in installation image.
559#
560# This function can be used only in src_install() phase.
646python_clean_installation_image() { 561python_clean_installation_image() {
562 if [[ "${EBUILD_PHASE}" != "install" ]]; then
563 die "${FUNCNAME}() can be used only in src_install() phase"
564 fi
565
647 _python_check_python_pkg_setup_execution 566 _python_check_python_pkg_setup_execution
648 _python_initialize_prefix_variables 567 _python_initialize_prefix_variables
649 568
650 local file files=() quiet="0" 569 local file files=() quiet="0"
651
652 # Check if phase is src_install().
653 [[ "${EBUILD_PHASE}" != "install" ]] && die "${FUNCNAME}() can be used only in src_install() phase"
654 570
655 while (($#)); do 571 while (($#)); do
656 case "$1" in 572 case "$1" in
657 -q|--quiet) 573 -q|--quiet)
658 quiet="1" 574 quiet="1"
709# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS 625# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS
710# @DESCRIPTION: 626# @DESCRIPTION:
711# Set this in EAPI <= 4 to indicate that current package supports installation for 627# Set this in EAPI <= 4 to indicate that current package supports installation for
712# multiple Python ABIs. 628# multiple Python ABIs.
713 629
630# @ECLASS-VARIABLE: PYTHON_TESTS_RESTRICTED_ABIS
631# @DESCRIPTION:
632# Space-separated list of Python ABI patterns. Testing in Python ABIs matching any Python ABI
633# patterns specified in this list is skipped.
634
714# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS 635# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS
715# @DESCRIPTION: 636# @DESCRIPTION:
716# Set this to export phase functions for the following ebuild phases: 637# Set this to export phase functions for the following ebuild phases:
717# src_prepare, src_configure, src_compile, src_test, src_install. 638# src_prepare(), src_configure(), src_compile(), src_test(), src_install().
718if ! has "${EAPI:-0}" 0 1; then 639if ! has "${EAPI:-0}" 0 1; then
719 python_src_prepare() { 640 python_src_prepare() {
720 _python_check_python_pkg_setup_execution 641 if [[ "${EBUILD_PHASE}" != "prepare" ]]; then
642 die "${FUNCNAME}() can be used only in src_prepare() phase"
643 fi
721 644
722 if ! _python_package_supporting_installation_for_multiple_python_abis; then 645 if ! _python_package_supporting_installation_for_multiple_python_abis; then
723 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 646 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
724 fi 647 fi
725 648
649 _python_check_python_pkg_setup_execution
650
726 if [[ "$#" -ne 0 ]]; then 651 if [[ "$#" -ne 0 ]]; then
727 die "${FUNCNAME}() does not accept arguments" 652 die "${FUNCNAME}() does not accept arguments"
728 fi 653 fi
729 654
730 python_copy_sources 655 python_copy_sources
731 } 656 }
732 657
733 for python_default_function in src_configure src_compile src_test src_install; do 658 for python_default_function in src_configure src_compile src_test; do
734 eval "python_${python_default_function}() { 659 eval "python_${python_default_function}() {
735 _python_check_python_pkg_setup_execution 660 if [[ \"\${EBUILD_PHASE}\" != \"${python_default_function#src_}\" ]]; then
661 die \"\${FUNCNAME}() can be used only in ${python_default_function}() phase\"
662 fi
736 663
737 if ! _python_package_supporting_installation_for_multiple_python_abis; then 664 if ! _python_package_supporting_installation_for_multiple_python_abis; then
738 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\" 665 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\"
739 fi 666 fi
667
668 _python_check_python_pkg_setup_execution
740 669
741 python_execute_function -d -s -- \"\$@\" 670 python_execute_function -d -s -- \"\$@\"
742 }" 671 }"
743 done 672 done
744 unset python_default_function 673 unset python_default_function
745 674
675 python_src_install() {
676 if [[ "${EBUILD_PHASE}" != "install" ]]; then
677 die "${FUNCNAME}() can be used only in src_install() phase"
678 fi
679
680 if ! _python_package_supporting_installation_for_multiple_python_abis; then
681 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
682 fi
683
684 _python_check_python_pkg_setup_execution
685
686 if has "${EAPI:-0}" 0 1 2 3; then
687 python_execute_function -d -s -- "$@"
688 else
689 python_installation() {
690 emake DESTDIR="${T}/images/${PYTHON_ABI}" install "$@"
691 }
692 python_execute_function -s python_installation "$@"
693 unset python_installation
694
695 python_merge_intermediate_installation_images "${T}/images"
696 fi
697 }
698
746 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then 699 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
747 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install 700 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
748 fi 701 fi
749fi 702fi
750 703
751if has "${EAPI:-0}" 0 1 2 3; then 704if has "${EAPI:-0}" 0 1 2 3 4; then
752 unset PYTHON_ABIS 705 unset PYTHON_ABIS
753fi 706fi
754 707
755_python_calculate_PYTHON_ABIS() { 708_python_calculate_PYTHON_ABIS() {
756 if ! _python_package_supporting_installation_for_multiple_python_abis; then 709 if ! _python_package_supporting_installation_for_multiple_python_abis; then
757 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 710 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
758 fi 711 fi
759 712
760 _python_initial_sanity_checks 713 _python_initial_sanity_checks
761 714
762 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3; then 715 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
763 local PYTHON_ABI restricted_ABI restricted_ABIs support_ABI supported_PYTHON_ABIS 716 local PYTHON_ABI
764
765 restricted_ABIs="${RESTRICT_PYTHON_ABIS// /$'\n'}"
766 717
767 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then 718 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
768 local cpython_enabled="0" 719 local cpython_enabled="0"
769 720
770 if [[ -z "${USE_PYTHON}" ]]; then 721 if [[ -z "${USE_PYTHON}" ]]; then
771 die "USE_PYTHON variable is empty" 722 die "USE_PYTHON variable is empty"
772 fi 723 fi
773 724
774 for PYTHON_ABI in ${USE_PYTHON}; do 725 for PYTHON_ABI in ${USE_PYTHON}; do
775 if ! has "${PYTHON_ABI}" ${_PYTHON_SUPPORTED_ABIS[@]}; then 726 if ! has "${PYTHON_ABI}" "${_PYTHON_GLOBALLY_SUPPORTED_ABIS[@]}"; then
776 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'" 727 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
777 fi 728 fi
778 729
779 if has "${PYTHON_ABI}" "${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}"; then 730 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then
780 cpython_enabled="1" 731 cpython_enabled="1"
781 fi 732 fi
782 733
783 support_ABI="1" 734 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
784 while read restricted_ABI; do 735 export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
785 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
786 support_ABI="0"
787 break
788 fi 736 fi
789 done <<< "${restricted_ABIs}"
790 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
791 done 737 done
792 738
793 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then 739 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
794 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}" 740 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
795 fi 741 fi
796 742
797 if [[ "${cpython_enabled}" == "0" ]]; then 743 if [[ "${cpython_enabled}" == "0" ]]; then
798 die "USE_PYTHON variable does not enable any CPython ABI" 744 die "USE_PYTHON variable does not enable any CPython ABI"
799 fi 745 fi
800 else 746 else
801 local python_version python2_version= python3_version= support_python_major_version 747 local python_version python2_version python3_version support_python_major_version
802 748
803 if ! has_version "dev-lang/python"; then 749 if ! has_version "dev-lang/python"; then
804 die "${FUNCNAME}(): 'dev-lang/python' is not installed" 750 die "${FUNCNAME}(): 'dev-lang/python' is not installed"
805 fi 751 fi
806 752
811 die "'${EPREFIX}/usr/bin/python2' is not valid symlink" 757 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
812 fi 758 fi
813 759
814 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 760 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
815 761
762 support_python_major_version="0"
816 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do 763 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
764 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
817 support_python_major_version="1" 765 support_python_major_version="1"
818 while read restricted_ABI; do 766 break
819 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
820 support_python_major_version="0"
821 fi 767 fi
822 done <<< "${restricted_ABIs}"
823 [[ "${support_python_major_version}" == "1" ]] && break
824 done 768 done
825 if [[ "${support_python_major_version}" == "1" ]]; then 769 if [[ "${support_python_major_version}" == "1" ]]; then
826 while read restricted_ABI; do 770 if _python_check_python_abi_matching --patterns-list "${python2_version}" "${RESTRICT_PYTHON_ABIS}"; then
827 if [[ "${python2_version}" == ${restricted_ABI} ]]; then
828 die "Active version of Python 2 is not supported by ${CATEGORY}/${PF}" 771 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}"
829 fi 772 fi
830 done <<< "${restricted_ABIs}"
831 else 773 else
832 python2_version="" 774 python2_version=""
833 fi 775 fi
834 fi 776 fi
835 777
838 die "'${EPREFIX}/usr/bin/python3' is not valid symlink" 780 die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
839 fi 781 fi
840 782
841 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 783 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
842 784
785 support_python_major_version="0"
843 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do 786 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
787 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
844 support_python_major_version="1" 788 support_python_major_version="1"
845 while read restricted_ABI; do 789 break
846 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
847 support_python_major_version="0"
848 fi 790 fi
849 done <<< "${restricted_ABIs}"
850 [[ "${support_python_major_version}" == "1" ]] && break
851 done 791 done
852 if [[ "${support_python_major_version}" == "1" ]]; then 792 if [[ "${support_python_major_version}" == "1" ]]; then
853 while read restricted_ABI; do 793 if _python_check_python_abi_matching --patterns-list "${python3_version}" "${RESTRICT_PYTHON_ABIS}"; then
854 if [[ "${python3_version}" == ${restricted_ABI} ]]; then
855 die "Active version of Python 3 is not supported by ${CATEGORY}/${PF}" 794 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
856 fi 795 fi
857 done <<< "${restricted_ABIs}"
858 else 796 else
859 python3_version="" 797 python3_version=""
860 fi 798 fi
861 fi 799 fi
862 800
887 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\"" 825 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\""
888 for prefix in PYTHON_USER_ PYTHON_; do 826 for prefix in PYTHON_USER_ PYTHON_; do
889 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then 827 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then
890 eval "array=(\"\${${prefix}${variable}[@]}\")" 828 eval "array=(\"\${${prefix}${variable}[@]}\")"
891 for element in "${array[@]}"; do 829 for element in "${array[@]}"; do
892 if [[ "${element}" =~ ^([[:alnum:]]|\.|-|\*|\[|\])+\ (\+|-)\ .+ ]]; then 830 if [[ "${element}" =~ ^${_PYTHON_ABI_PATTERN_REGEX}\ (\+|-)\ .+ ]]; then
893 pattern="${element%% *}" 831 pattern="${element%% *}"
894 element="${element#* }" 832 element="${element#* }"
895 operator="${element%% *}" 833 operator="${element%% *}"
896 flags="${element#* }" 834 flags="${element#* }"
897 if [[ "${PYTHON_ABI}" == ${pattern} ]]; then 835 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
898 if [[ "${operator}" == "+" ]]; then 836 if [[ "${operator}" == "+" ]]; then
899 eval "export ${variable}+=\"\${variable:+ }${flags}\"" 837 eval "export ${variable}+=\"\${variable:+ }${flags}\""
900 elif [[ "${operator}" == "-" ]]; then 838 elif [[ "${operator}" == "-" ]]; then
901 flags="${flags// /$'\n'}" 839 flags="${flags// /$'\n'}"
902 old_value="${!variable// /$'\n'}" 840 old_value="${!variable// /$'\n'}"
936# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments] 874# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
937# @DESCRIPTION: 875# @DESCRIPTION:
938# Execute specified function for each value of PYTHON_ABIS, optionally passing additional 876# Execute specified function for each value of PYTHON_ABIS, optionally passing additional
939# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables. 877# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables.
940python_execute_function() { 878python_execute_function() {
941 _python_check_python_pkg_setup_execution
942
943 if ! _python_package_supporting_installation_for_multiple_python_abis; then 879 if ! _python_package_supporting_installation_for_multiple_python_abis; then
944 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 880 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
945 fi 881 fi
946 882
883 _python_check_python_pkg_setup_execution
947 _python_set_color_variables 884 _python_set_color_variables
948 885
949 local action action_message action_message_template= default_function="0" failure_message failure_message_template= final_ABI="0" function iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" return_code separate_build_dirs="0" source_dir= 886 local action action_message action_message_template default_function="0" failure_message failure_message_template final_ABI="0" function iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" return_code separate_build_dirs="0" source_dir
950 887
951 while (($#)); do 888 while (($#)); do
952 case "$1" in 889 case "$1" in
953 --action-message) 890 --action-message)
954 action_message_template="$2" 891 action_message_template="$2"
1066 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)" 1003 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)"
1067 else 1004 else
1068 iterated_PYTHON_ABIS="${PYTHON_ABIS}" 1005 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
1069 fi 1006 fi
1070 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 1007 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1008 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then
1009 if [[ "${quiet}" == "0" ]]; then
1010 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation_and_version) skipped${_NORMAL}"
1011 fi
1012 continue
1013 fi
1014
1071 _python_prepare_flags 1015 _python_prepare_flags
1072 1016
1073 if [[ "${quiet}" == "0" ]]; then 1017 if [[ "${quiet}" == "0" ]]; then
1074 if [[ -n "${action_message_template}" ]]; then 1018 if [[ -n "${action_message_template}" ]]; then
1075 eval "action_message=\"${action_message_template}\"" 1019 eval "action_message=\"${action_message_template}\""
1076 else 1020 else
1077 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..." 1021 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation_and_version)..."
1078 fi 1022 fi
1079 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}" 1023 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
1080 fi 1024 fi
1081 1025
1082 if [[ "${separate_build_dirs}" == "1" ]]; then 1026 if [[ "${separate_build_dirs}" == "1" ]]; then
1106 1050
1107 if [[ "${return_code}" -ne 0 ]]; then 1051 if [[ "${return_code}" -ne 0 ]]; then
1108 if [[ -n "${failure_message_template}" ]]; then 1052 if [[ -n "${failure_message_template}" ]]; then
1109 eval "failure_message=\"${failure_message_template}\"" 1053 eval "failure_message=\"${failure_message_template}\""
1110 else 1054 else
1111 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function" 1055 failure_message="${action} failed with $(python_get_implementation_and_version) in ${function}() function"
1112 fi 1056 fi
1113 1057
1114 if [[ "${nonfatal}" == "1" ]]; then 1058 if [[ "${nonfatal}" == "1" ]]; then
1115 if [[ "${quiet}" == "0" ]]; then 1059 if [[ "${quiet}" == "0" ]]; then
1116 ewarn "${failure_message}" 1060 ewarn "${failure_message}"
1169# @FUNCTION: python_copy_sources 1113# @FUNCTION: python_copy_sources
1170# @USAGE: <directory="${S}"> [directory] 1114# @USAGE: <directory="${S}"> [directory]
1171# @DESCRIPTION: 1115# @DESCRIPTION:
1172# Copy unpacked sources of current package to separate build directory for each Python ABI. 1116# Copy unpacked sources of current package to separate build directory for each Python ABI.
1173python_copy_sources() { 1117python_copy_sources() {
1174 _python_check_python_pkg_setup_execution
1175
1176 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1118 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1177 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1119 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1178 fi 1120 fi
1121
1122 _python_check_python_pkg_setup_execution
1179 1123
1180 local dir dirs=() PYTHON_ABI 1124 local dir dirs=() PYTHON_ABI
1181 1125
1182 if [[ "$#" -eq 0 ]]; then 1126 if [[ "$#" -eq 0 ]]; then
1183 if [[ "${WORKDIR}" == "${S}" ]]; then 1127 if [[ "${WORKDIR}" == "${S}" ]]; then
1200# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files] 1144# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files]
1201# @DESCRIPTION: 1145# @DESCRIPTION:
1202# Generate wrapper scripts. Existing files are overwritten only with --force option. 1146# Generate wrapper scripts. Existing files are overwritten only with --force option.
1203# If --respect-EPYTHON option is specified, then generated wrapper scripts will 1147# If --respect-EPYTHON option is specified, then generated wrapper scripts will
1204# respect EPYTHON variable at run time. 1148# respect EPYTHON variable at run time.
1149#
1150# This function can be used only in src_install() phase.
1205python_generate_wrapper_scripts() { 1151python_generate_wrapper_scripts() {
1206 _python_check_python_pkg_setup_execution 1152 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1153 die "${FUNCNAME}() can be used only in src_install() phase"
1154 fi
1207 1155
1208 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1156 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1209 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1157 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1210 fi 1158 fi
1211 1159
1160 _python_check_python_pkg_setup_execution
1212 _python_initialize_prefix_variables 1161 _python_initialize_prefix_variables
1213 1162
1214 local eselect_python_option file force="0" quiet="0" PYTHON_ABI python2_enabled="0" python3_enabled="0" respect_EPYTHON="0" 1163 local eselect_python_option file force="0" quiet="0" PYTHON_ABI PYTHON_ABIS_list python2_enabled="0" python3_enabled="0" respect_EPYTHON="0"
1215 1164
1216 while (($#)); do 1165 while (($#)); do
1217 case "$1" in 1166 case "$1" in
1218 -E|--respect-EPYTHON) 1167 -E|--respect-EPYTHON)
1219 respect_EPYTHON="1" 1168 respect_EPYTHON="1"
1241 if [[ "$#" -eq 0 ]]; then 1190 if [[ "$#" -eq 0 ]]; then
1242 die "${FUNCNAME}(): Missing arguments" 1191 die "${FUNCNAME}(): Missing arguments"
1243 fi 1192 fi
1244 1193
1245 _python_calculate_PYTHON_ABIS 1194 _python_calculate_PYTHON_ABIS
1246 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do 1195 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
1247 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 1196 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
1248 python2_enabled="1" 1197 python2_enabled="1"
1249 fi 1198 fi
1250 done 1199 done
1251 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do 1200 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
1252 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 1201 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
1253 python3_enabled="1" 1202 python3_enabled="1"
1254 fi 1203 fi
1255 done 1204 done
1256 1205
1262 eselect_python_option="--python3" 1211 eselect_python_option="--python3"
1263 else 1212 else
1264 die "${FUNCNAME}(): Unsupported environment" 1213 die "${FUNCNAME}(): Unsupported environment"
1265 fi 1214 fi
1266 1215
1216 PYTHON_ABIS_list="$("$(PYTHON -f)" -c "print(', '.join('\"%s\"' % x for x in reversed('${PYTHON_ABIS}'.split())))")"
1217
1267 for file in "$@"; do 1218 for file in "$@"; do
1268 if [[ -f "${file}" && "${force}" == "0" ]]; then 1219 if [[ -f "${file}" && "${force}" == "0" ]]; then
1269 die "${FUNCNAME}(): '$1' already exists" 1220 die "${FUNCNAME}(): '${file}' already exists"
1270 fi 1221 fi
1271 1222
1272 if [[ "${quiet}" == "0" ]]; then 1223 if [[ "${quiet}" == "0" ]]; then
1273 einfo "Generating '${file#${ED%/}}' wrapper script" 1224 einfo "Generating '${file#${ED%/}}' wrapper script"
1274 fi 1225 fi
1280import os 1231import os
1281import re 1232import re
1282import subprocess 1233import subprocess
1283import sys 1234import sys
1284 1235
1236cpython_ABI_re = re.compile(r"^(\d+\.\d+)$")
1237jython_ABI_re = re.compile(r"^(\d+\.\d+)-jython$")
1238pypy_ABI_re = re.compile(r"^\d+\.\d+-pypy-(\d+\.\d+)$")
1285EPYTHON_re = re.compile(r"^python(\d+\.\d+)$") 1239cpython_interpreter_re = re.compile(r"^python(\d+\.\d+)$")
1240jython_interpreter_re = re.compile(r"^jython(\d+\.\d+)$")
1241pypy_interpreter_re = re.compile(r"^pypy-c(\d+\.\d+)$")
1286python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)") 1242cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)")
1243python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)")
1287python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$") 1244python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1245
1246pypy_versions_mapping = {
1247 "1.5": "2.7"
1248}
1249
1250def get_PYTHON_ABI(python_interpreter):
1251 cpython_matched = cpython_interpreter_re.match(python_interpreter)
1252 jython_matched = jython_interpreter_re.match(python_interpreter)
1253 pypy_matched = pypy_interpreter_re.match(python_interpreter)
1254 if cpython_matched is not None:
1255 PYTHON_ABI = cpython_matched.group(1)
1256 elif jython_matched is not None:
1257 PYTHON_ABI = jython_matched.group(1) + "-jython"
1258 elif pypy_matched is not None:
1259 PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1)
1260 else:
1261 PYTHON_ABI = None
1262 return PYTHON_ABI
1263
1264def get_python_interpreter(PYTHON_ABI):
1265 cpython_matched = cpython_ABI_re.match(PYTHON_ABI)
1266 jython_matched = jython_ABI_re.match(PYTHON_ABI)
1267 pypy_matched = pypy_ABI_re.match(PYTHON_ABI)
1268 if cpython_matched is not None:
1269 python_interpreter = "python" + cpython_matched.group(1)
1270 elif jython_matched is not None:
1271 python_interpreter = "jython" + jython_matched.group(1)
1272 elif pypy_matched is not None:
1273 python_interpreter = "pypy-c" + pypy_matched.group(1)
1274 else:
1275 python_interpreter = None
1276 return python_interpreter
1288 1277
1289EOF 1278EOF
1290 if [[ "$?" != "0" ]]; then 1279 if [[ "$?" != "0" ]]; then
1291 die "${FUNCNAME}(): Generation of '$1' failed" 1280 die "${FUNCNAME}(): Generation of '$1' failed"
1292 fi 1281 fi
1293 if [[ "${respect_EPYTHON}" == "1" ]]; then 1282 if [[ "${respect_EPYTHON}" == "1" ]]; then
1294 cat << EOF >> "${file}" 1283 cat << EOF >> "${file}"
1295EPYTHON = os.environ.get("EPYTHON") 1284python_interpreter = os.environ.get("EPYTHON")
1296if EPYTHON: 1285if python_interpreter:
1297 EPYTHON_matched = EPYTHON_re.match(EPYTHON) 1286 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1298 if EPYTHON_matched: 1287 if PYTHON_ABI is None:
1299 PYTHON_ABI = EPYTHON_matched.group(1)
1300 else:
1301 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON) 1288 sys.stderr.write("%s: EPYTHON variable has unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1302 sys.exit(1) 1289 sys.exit(1)
1303else: 1290else:
1304 try: 1291 try:
1292 environment = os.environ.copy()
1293 environment["ROOT"] = "/"
1305 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1294 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1306 if eselect_process.wait() != 0: 1295 if eselect_process.wait() != 0:
1307 raise ValueError 1296 raise ValueError
1308 except (OSError, ValueError): 1297 except (OSError, ValueError):
1309 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1298 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1310 sys.exit(1) 1299 sys.exit(1)
1311 1300
1312 EPYTHON = eselect_process.stdout.read() 1301 python_interpreter = eselect_process.stdout.read()
1313 if not isinstance(EPYTHON, str): 1302 if not isinstance(python_interpreter, str):
1314 # Python 3 1303 # Python 3
1315 EPYTHON = EPYTHON.decode() 1304 python_interpreter = python_interpreter.decode()
1316 EPYTHON = EPYTHON.rstrip("\n") 1305 python_interpreter = python_interpreter.rstrip("\n")
1317 1306
1318 EPYTHON_matched = EPYTHON_re.match(EPYTHON) 1307 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1319 if EPYTHON_matched: 1308 if PYTHON_ABI is None:
1320 PYTHON_ABI = EPYTHON_matched.group(1)
1321 else:
1322 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON) 1309 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1323 sys.exit(1) 1310 sys.exit(1)
1324EOF
1325 if [[ "$?" != "0" ]]; then
1326 die "${FUNCNAME}(): Generation of '$1' failed"
1327 fi
1328 else
1329 cat << EOF >> "${file}"
1330try:
1331 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE)
1332 if eselect_process.wait() != 0:
1333 raise ValueError
1334except (OSError, ValueError):
1335 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
1336 sys.exit(1)
1337 1311
1338EPYTHON = eselect_process.stdout.read() 1312wrapper_script_path = os.path.realpath(sys.argv[0])
1339if not isinstance(EPYTHON, str): 1313target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1340 # Python 3 1314if not os.path.exists(target_executable_path):
1341 EPYTHON = EPYTHON.decode() 1315 sys.stderr.write("%s: '%s' does not exist\n" % (sys.argv[0], target_executable_path))
1342EPYTHON = EPYTHON.rstrip("\n")
1343
1344EPYTHON_matched = EPYTHON_re.match(EPYTHON)
1345if EPYTHON_matched:
1346 PYTHON_ABI = EPYTHON_matched.group(1)
1347else:
1348 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON)
1349 sys.exit(1) 1316 sys.exit(1)
1350EOF 1317EOF
1351 if [[ "$?" != "0" ]]; then 1318 if [[ "$?" != "0" ]]; then
1352 die "${FUNCNAME}(): Generation of '$1' failed" 1319 die "${FUNCNAME}(): Generation of '$1' failed"
1353 fi 1320 fi
1321 else
1322 cat << EOF >> "${file}"
1323try:
1324 environment = os.environ.copy()
1325 environment["ROOT"] = "/"
1326 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1327 if eselect_process.wait() != 0:
1328 raise ValueError
1329except (OSError, ValueError):
1330 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1331 sys.exit(1)
1332
1333python_interpreter = eselect_process.stdout.read()
1334if not isinstance(python_interpreter, str):
1335 # Python 3
1336 python_interpreter = python_interpreter.decode()
1337python_interpreter = python_interpreter.rstrip("\n")
1338
1339PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1340if PYTHON_ABI is None:
1341 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1342 sys.exit(1)
1343
1344wrapper_script_path = os.path.realpath(sys.argv[0])
1345for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1346 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1347 if os.path.exists(target_executable_path):
1348 break
1349else:
1350 sys.stderr.write("%s: No target script exists for '%s'\n" % (sys.argv[0], wrapper_script_path))
1351 sys.exit(1)
1352
1353python_interpreter = get_python_interpreter(PYTHON_ABI)
1354if python_interpreter is None:
1355 sys.stderr.write("%s: Unrecognized Python ABI '%s'\n" % (sys.argv[0], PYTHON_ABI))
1356 sys.exit(1)
1357EOF
1358 if [[ "$?" != "0" ]]; then
1359 die "${FUNCNAME}(): Generation of '$1' failed"
1360 fi
1354 fi 1361 fi
1355 cat << EOF >> "${file}" 1362 cat << EOF >> "${file}"
1356
1357wrapper_script_path = os.path.realpath(sys.argv[0])
1358target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1359os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1360os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1361os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1362if not os.path.exists(target_executable_path):
1363 sys.stderr.write("'%s' does not exist\n" % target_executable_path)
1364 sys.exit(1)
1365 1363
1366target_executable = open(target_executable_path, "rb") 1364target_executable = open(target_executable_path, "rb")
1367target_executable_first_line = target_executable.readline() 1365target_executable_first_line = target_executable.readline()
1366target_executable.close()
1368if not isinstance(target_executable_first_line, str): 1367if not isinstance(target_executable_first_line, str):
1369 # Python 3 1368 # Python 3
1370 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace") 1369 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1371 1370
1371options = []
1372python_shebang_options_matched = python_shebang_options_re.match(target_executable_first_line)
1373if python_shebang_options_matched is not None:
1374 options = [python_shebang_options_matched.group(1)]
1375
1372python_shebang_matched = python_shebang_re.match(target_executable_first_line) 1376cpython_shebang_matched = cpython_shebang_re.match(target_executable_first_line)
1373target_executable.close()
1374 1377
1375if python_shebang_matched: 1378if cpython_shebang_matched is not None:
1376 try: 1379 try:
1377 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON 1380 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % python_interpreter
1378 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1" 1381 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1379 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE) 1382 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1380 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] 1383 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1381 if python_verification_process.wait() != 0: 1384 if python_verification_process.wait() != 0:
1382 raise ValueError 1385 raise ValueError
1387 python_verification_output = python_verification_output.decode() 1390 python_verification_output = python_verification_output.decode()
1388 1391
1389 if not python_verification_output_re.match(python_verification_output): 1392 if not python_verification_output_re.match(python_verification_output):
1390 raise ValueError 1393 raise ValueError
1391 1394
1395 if cpython_interpreter_re.match(python_interpreter) is not None:
1396 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1397 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1398 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1399
1400 if hasattr(os, "execv"):
1392 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv) 1401 os.execv(python_interpreter_path, [python_interpreter_path] + options + sys.argv)
1402 else:
1403 sys.exit(subprocess.Popen([python_interpreter_path] + options + sys.argv).wait())
1404 except (KeyboardInterrupt, SystemExit):
1405 raise
1393 except: 1406 except:
1394 pass 1407 pass
1395 if "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION" in os.environ: 1408 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1396 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] 1409 if variable in os.environ:
1410 del os.environ[variable]
1397 1411
1412if hasattr(os, "execv"):
1398os.execv(target_executable_path, sys.argv) 1413 os.execv(target_executable_path, sys.argv)
1414else:
1415 sys.exit(subprocess.Popen([target_executable_path] + sys.argv[1:]).wait())
1399EOF 1416EOF
1400 if [[ "$?" != "0" ]]; then 1417 if [[ "$?" != "0" ]]; then
1401 die "${FUNCNAME}(): Generation of '$1' failed" 1418 die "${FUNCNAME}(): Generation of '$1' failed"
1402 fi 1419 fi
1403 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed" 1420 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed"
1404 done 1421 done
1405} 1422}
1406 1423
1424# @ECLASS-VARIABLE: PYTHON_VERSIONED_SCRIPTS
1425# @DESCRIPTION:
1426# Array of regular expressions of paths to versioned Python scripts.
1427# Python scripts in /usr/bin and /usr/sbin are versioned by default.
1428
1429# @ECLASS-VARIABLE: PYTHON_VERSIONED_EXECUTABLES
1430# @DESCRIPTION:
1431# Array of regular expressions of paths to versioned executables (including Python scripts).
1432
1433# @ECLASS-VARIABLE: PYTHON_NONVERSIONED_EXECUTABLES
1434# @DESCRIPTION:
1435# Array of regular expressions of paths to nonversioned executables (including Python scripts).
1436
1437# @FUNCTION: python_merge_intermediate_installation_images
1438# @USAGE: [-q|--quiet] [--] <intermediate_installation_images_directory>
1439# @DESCRIPTION:
1440# Merge intermediate installation images into installation image.
1441#
1442# This function can be used only in src_install() phase.
1443python_merge_intermediate_installation_images() {
1444 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1445 die "${FUNCNAME}() can be used only in src_install() phase"
1446 fi
1447
1448 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1449 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1450 fi
1451
1452 _python_check_python_pkg_setup_execution
1453 _python_initialize_prefix_variables
1454
1455 local absolute_file b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=()
1456
1457 while (($#)); do
1458 case "$1" in
1459 -q|--quiet)
1460 quiet="1"
1461 ;;
1462 --)
1463 shift
1464 break
1465 ;;
1466 -*)
1467 die "${FUNCNAME}(): Unrecognized option '$1'"
1468 ;;
1469 *)
1470 break
1471 ;;
1472 esac
1473 shift
1474 done
1475
1476 if [[ "$#" -ne 1 ]]; then
1477 die "${FUNCNAME}() requires 1 argument"
1478 fi
1479
1480 intermediate_installation_images_directory="$1"
1481
1482 if [[ ! -d "${intermediate_installation_images_directory}" ]]; then
1483 die "${FUNCNAME}(): Intermediate installation images directory '${intermediate_installation_images_directory}' does not exist"
1484 fi
1485
1486 _python_calculate_PYTHON_ABIS
1487 if [[ "$(PYTHON -f --ABI)" == 3.* ]]; then
1488 b="b"
1489 fi
1490
1491 while read -d $'\0' -r file; do
1492 files+=("${file}")
1493 done < <("$(PYTHON -f)" -c \
1494"import os
1495import sys
1496
1497if hasattr(sys.stdout, 'buffer'):
1498 # Python 3
1499 stdout = sys.stdout.buffer
1500else:
1501 # Python 2
1502 stdout = sys.stdout
1503
1504files_set = set()
1505
1506os.chdir(${b}'${intermediate_installation_images_directory}')
1507
1508for PYTHON_ABI in ${b}'${PYTHON_ABIS}'.split():
1509 for root, dirs, files in os.walk(PYTHON_ABI + ${b}'${EPREFIX}'):
1510 root = root[len(PYTHON_ABI + ${b}'${EPREFIX}')+1:]
1511 files_set.update(root + ${b}'/' + file for file in files)
1512
1513for file in sorted(files_set):
1514 stdout.write(file)
1515 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of files in intermediate installation images")
1516
1517 for PYTHON_ABI in ${PYTHON_ABIS}; do
1518 if [[ ! -d "${intermediate_installation_images_directory}/${PYTHON_ABI}" ]]; then
1519 die "${FUNCNAME}(): Intermediate installation image for Python ABI '${PYTHON_ABI}' does not exist"
1520 fi
1521
1522 pushd "${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}" > /dev/null || die "pushd failed"
1523
1524 for file in "${files[@]}"; do
1525 version_executable="0"
1526 for regex in "/usr/bin/.*" "/usr/sbin/.*" "${PYTHON_VERSIONED_SCRIPTS[@]}"; do
1527 if [[ "/${file}" =~ ^${regex}$ ]]; then
1528 version_executable="1"
1529 break
1530 fi
1531 done
1532 for regex in "${PYTHON_VERSIONED_EXECUTABLES[@]}"; do
1533 if [[ "/${file}" =~ ^${regex}$ ]]; then
1534 version_executable="2"
1535 break
1536 fi
1537 done
1538 if [[ "${version_executable}" != "0" ]]; then
1539 for regex in "${PYTHON_NONVERSIONED_EXECUTABLES[@]}"; do
1540 if [[ "/${file}" =~ ^${regex}$ ]]; then
1541 version_executable="0"
1542 break
1543 fi
1544 done
1545 fi
1546
1547 [[ "${version_executable}" == "0" ]] && continue
1548
1549 if [[ -L "${file}" ]]; then
1550 absolute_file="$(readlink "${file}")"
1551 if [[ "${absolute_file}" == /* ]]; then
1552 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file##/}"
1553 else
1554 if [[ "${file}" == */* ]]; then
1555 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file%/*}/${absolute_file}"
1556 else
1557 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file}"
1558 fi
1559 fi
1560 else
1561 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file}"
1562 fi
1563
1564 [[ ! -x "${absolute_file}" ]] && continue
1565
1566 shebang="$(head -n1 "${absolute_file}")" || die "Extraction of shebang from '${absolute_file}' failed"
1567
1568 if [[ "${version_executable}" == "2" ]]; then
1569 wrapper_scripts+=("${ED}${file}")
1570 elif [[ "${version_executable}" == "1" ]]; then
1571 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then
1572 wrapper_scripts+=("${ED}${file}")
1573 else
1574 version_executable="0"
1575 fi
1576 fi
1577
1578 [[ "${version_executable}" == "0" ]] && continue
1579
1580 if [[ -e "${file}-${PYTHON_ABI}" ]]; then
1581 die "${FUNCNAME}(): '${EPREFIX}/${file}-${PYTHON_ABI}' already exists"
1582 fi
1583
1584 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
1585
1586 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then
1587 if [[ -L "${file}-${PYTHON_ABI}" ]]; then
1588 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${absolute_file}"
1589 else
1590 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}"
1591 fi
1592 fi
1593 done
1594
1595 popd > /dev/null || die "popd failed"
1596
1597 if ROOT="/" has_version sys-apps/coreutils; then
1598 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1599 else
1600 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1601 fi
1602 done
1603
1604 rm -fr "${intermediate_installation_images_directory}"
1605
1606 if [[ "${#wrapper_scripts[@]}" -ge 1 ]]; then
1607 rm -f "${T}/python_wrapper_scripts"
1608
1609 for file in "${wrapper_scripts[@]}"; do
1610 echo -n "${file}" >> "${T}/python_wrapper_scripts"
1611 echo -en "\x00" >> "${T}/python_wrapper_scripts"
1612 done
1613
1614 while read -d $'\0' -r file; do
1615 wrapper_scripts_set+=("${file}")
1616 done < <("$(PYTHON -f)" -c \
1617"import sys
1618
1619if hasattr(sys.stdout, 'buffer'):
1620 # Python 3
1621 stdout = sys.stdout.buffer
1622else:
1623 # Python 2
1624 stdout = sys.stdout
1625
1626python_wrapper_scripts_file = open('${T}/python_wrapper_scripts', 'rb')
1627files = set(python_wrapper_scripts_file.read().rstrip(${b}'\x00').split(${b}'\x00'))
1628python_wrapper_scripts_file.close()
1629
1630for file in sorted(files):
1631 stdout.write(file)
1632 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1633
1634 python_generate_wrapper_scripts $([[ "${quiet}" == "1" ]] && echo --quiet) "${wrapper_scripts_set[@]}"
1635 fi
1636}
1637
1407# ================================================================================================ 1638# ================================================================================================
1408# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ========== 1639# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ==========
1409# ================================================================================================ 1640# ================================================================================================
1410 1641
1411unset EPYTHON PYTHON_ABI 1642unset EPYTHON PYTHON_ABI
1412 1643
1413# @FUNCTION: python_set_active_version 1644# @FUNCTION: python_set_active_version
1414# @USAGE: <CPython_ABI|2|3> 1645# @USAGE: <Python_ABI|2|3>
1415# @DESCRIPTION: 1646# @DESCRIPTION:
1416# Set specified version of CPython as active version of Python. 1647# Set locally active version of Python.
1648# If Python_ABI argument is specified, then version of Python corresponding to Python_ABI is used.
1649# If 2 argument is specified, then active version of CPython 2 is used.
1650# If 3 argument is specified, then active version of CPython 3 is used.
1417# 1651#
1418# This function can be used only in pkg_setup() phase. 1652# This function can be used only in pkg_setup() phase.
1419python_set_active_version() { 1653python_set_active_version() {
1420 # Check if phase is pkg_setup(). 1654 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
1421 [[ "${EBUILD_PHASE}" != "setup" ]] && die "${FUNCNAME}() can be used only in pkg_setup() phase" 1655 die "${FUNCNAME}() can be used only in pkg_setup() phase"
1656 fi
1422 1657
1423 if _python_package_supporting_installation_for_multiple_python_abis; then 1658 if _python_package_supporting_installation_for_multiple_python_abis; then
1424 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1659 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1425 fi 1660 fi
1426 1661
1429 fi 1664 fi
1430 1665
1431 _python_initial_sanity_checks 1666 _python_initial_sanity_checks
1432 1667
1433 if [[ -z "${PYTHON_ABI}" ]]; then 1668 if [[ -z "${PYTHON_ABI}" ]]; then
1434 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1669 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
1435 if ! _python_implementation && ! has_version "dev-lang/python:$1"; then 1670 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
1436 die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed" 1671 # so it does not need to be exported to subprocesses.
1672 PYTHON_ABI="$1"
1673 if ! _python_implementation && ! has_version "$(python_get_implementational_package)"; then
1674 die "${FUNCNAME}(): '$(python_get_implementational_package)' is not installed"
1437 fi 1675 fi
1438 export EPYTHON="$(PYTHON "$1")" 1676 export EPYTHON="$(PYTHON "$1")"
1439 elif [[ "$1" == "2" ]]; then 1677 elif [[ "$1" == "2" ]]; then
1440 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then 1678 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then
1441 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed" 1679 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed"
1442 fi 1680 fi
1443 export EPYTHON="$(PYTHON -2)" 1681 export EPYTHON="$(PYTHON -2)"
1682 PYTHON_ABI="${EPYTHON#python}"
1683 PYTHON_ABI="${PYTHON_ABI%%-*}"
1444 elif [[ "$1" == "3" ]]; then 1684 elif [[ "$1" == "3" ]]; then
1445 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then 1685 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then
1446 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed" 1686 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed"
1447 fi 1687 fi
1448 export EPYTHON="$(PYTHON -3)" 1688 export EPYTHON="$(PYTHON -3)"
1689 PYTHON_ABI="${EPYTHON#python}"
1690 PYTHON_ABI="${PYTHON_ABI%%-*}"
1449 else 1691 else
1450 die "${FUNCNAME}(): Unrecognized argument '$1'" 1692 die "${FUNCNAME}(): Unrecognized argument '$1'"
1451 fi 1693 fi
1452
1453 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
1454 # so it does not need to be exported to subprocesses.
1455 PYTHON_ABI="${EPYTHON#python}"
1456 PYTHON_ABI="${PYTHON_ABI%%-*}"
1457 fi 1694 fi
1458 1695
1459 _python_final_sanity_checks 1696 _python_final_sanity_checks
1460 1697
1461 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 1698 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
1462 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 1699 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
1463} 1700}
1464 1701
1465# @FUNCTION: python_need_rebuild 1702# @FUNCTION: python_need_rebuild
1703# @DESCRIPTION:
1466# @DESCRIPTION: Mark current package for rebuilding by python-updater after 1704# Mark current package for rebuilding by python-updater after
1467# switching of active version of Python. 1705# switching of active version of Python.
1468python_need_rebuild() { 1706python_need_rebuild() {
1469 _python_check_python_pkg_setup_execution
1470
1471 if _python_package_supporting_installation_for_multiple_python_abis; then 1707 if _python_package_supporting_installation_for_multiple_python_abis; then
1472 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1708 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1473 fi 1709 fi
1710
1711 _python_check_python_pkg_setup_execution
1474 1712
1475 if [[ "$#" -ne 0 ]]; then 1713 if [[ "$#" -ne 0 ]]; then
1476 die "${FUNCNAME}() does not accept arguments" 1714 die "${FUNCNAME}() does not accept arguments"
1477 fi 1715 fi
1478 1716
1481 1719
1482# ================================================================================================ 1720# ================================================================================================
1483# ======================================= GETTER FUNCTIONS ======================================= 1721# ======================================= GETTER FUNCTIONS =======================================
1484# ================================================================================================ 1722# ================================================================================================
1485 1723
1486_PYTHON_ABI_EXTRACTION_COMMAND='import platform 1724_PYTHON_ABI_EXTRACTION_COMMAND=\
1725'import platform
1487import sys 1726import sys
1488sys.stdout.write(".".join(str(x) for x in sys.version_info[:2])) 1727sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
1489if platform.system()[:4] == "Java": 1728if platform.system()[:4] == "Java":
1490 sys.stdout.write("-jython")' 1729 sys.stdout.write("-jython")
1730elif hasattr(platform, "python_implementation") and platform.python_implementation() == "PyPy":
1731 sys.stdout.write("-pypy-" + ".".join(str(x) for x in sys.pypy_version_info[:2]))'
1491 1732
1492_python_get_implementation() { 1733_python_get_implementation() {
1734 local ignore_invalid="0"
1735
1736 while (($#)); do
1737 case "$1" in
1738 --ignore-invalid)
1739 ignore_invalid="1"
1740 ;;
1741 --)
1742 shift
1743 break
1744 ;;
1745 -*)
1746 die "${FUNCNAME}(): Unrecognized option '$1'"
1747 ;;
1748 *)
1749 break
1750 ;;
1751 esac
1752 shift
1753 done
1754
1493 if [[ "$#" -ne 1 ]]; then 1755 if [[ "$#" -ne 1 ]]; then
1494 die "${FUNCNAME}() requires 1 argument" 1756 die "${FUNCNAME}() requires 1 argument"
1495 fi 1757 fi
1496 1758
1497 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1759 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
1498 echo "CPython" 1760 echo "CPython"
1499 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then 1761 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
1500 echo "Jython" 1762 echo "Jython"
1763 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
1764 echo "PyPy"
1501 else 1765 else
1766 if [[ "${ignore_invalid}" == "0" ]]; then
1502 die "${FUNCNAME}(): Unrecognized Python ABI '$1'" 1767 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
1768 fi
1503 fi 1769 fi
1504} 1770}
1505 1771
1506# @FUNCTION: PYTHON 1772# @FUNCTION: PYTHON
1507# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}"> 1773# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}">
1508# @DESCRIPTION: 1774# @DESCRIPTION:
1509# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument 1775# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument
1510# is ommitted, then PYTHON_ABI environment variable must be set and is used. 1776# is ommitted, then PYTHON_ABI environment variable must be set and is used.
1511# If -2 option is specified, then active version of Python 2 is used. 1777# If -2 option is specified, then active version of CPython 2 is used.
1512# If -3 option is specified, then active version of Python 3 is used. 1778# If -3 option is specified, then active version of CPython 3 is used.
1513# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1779# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1514# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously. 1780# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously.
1515# If --ABI option is specified, then only specified Python ABI is printed instead of 1781# If --ABI option is specified, then only specified Python ABI is printed instead of
1516# filename of Python interpreter. 1782# filename of Python interpreter.
1517# If --absolute-path option is specified, then absolute path to Python interpreter is printed. 1783# If --absolute-path option is specified, then absolute path to Python interpreter is printed.
1566 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1832 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1567 fi 1833 fi
1568 _python_calculate_PYTHON_ABIS 1834 _python_calculate_PYTHON_ABIS
1569 PYTHON_ABI="${PYTHON_ABIS##* }" 1835 PYTHON_ABI="${PYTHON_ABIS##* }"
1570 elif [[ "${python2}" == "1" ]]; then 1836 elif [[ "${python2}" == "1" ]]; then
1571 PYTHON_ABI="$(eselect python show --python2 --ABI)" 1837 PYTHON_ABI="$(ROOT="/" eselect python show --python2 --ABI)"
1572 if [[ -z "${PYTHON_ABI}" ]]; then 1838 if [[ -z "${PYTHON_ABI}" ]]; then
1573 die "${FUNCNAME}(): Active version of Python 2 not set" 1839 die "${FUNCNAME}(): Active version of CPython 2 not set"
1574 elif [[ "${PYTHON_ABI}" != "2."* ]]; then 1840 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1575 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`" 1841 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1576 fi 1842 fi
1577 elif [[ "${python3}" == "1" ]]; then 1843 elif [[ "${python3}" == "1" ]]; then
1578 PYTHON_ABI="$(eselect python show --python3 --ABI)" 1844 PYTHON_ABI="$(ROOT="/" eselect python show --python3 --ABI)"
1579 if [[ -z "${PYTHON_ABI}" ]]; then 1845 if [[ -z "${PYTHON_ABI}" ]]; then
1580 die "${FUNCNAME}(): Active version of Python 3 not set" 1846 die "${FUNCNAME}(): Active version of CPython 3 not set"
1581 elif [[ "${PYTHON_ABI}" != "3."* ]]; then 1847 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1582 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`" 1848 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1583 fi 1849 fi
1584 elif _python_package_supporting_installation_for_multiple_python_abis; then 1850 elif _python_package_supporting_installation_for_multiple_python_abis; then
1585 if ! _python_abi-specific_local_scope; then 1851 if ! _python_abi-specific_local_scope; then
1611 return 1877 return
1612 else 1878 else
1613 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1879 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1614 python_interpreter="python${PYTHON_ABI}" 1880 python_interpreter="python${PYTHON_ABI}"
1615 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1881 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1616 python_interpreter="jython-${PYTHON_ABI%-jython}" 1882 python_interpreter="jython${PYTHON_ABI%-jython}"
1883 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
1884 python_interpreter="pypy-c${PYTHON_ABI#*-pypy-}"
1617 fi 1885 fi
1618 1886
1619 if [[ "${absolute_path_output}" == "1" ]]; then 1887 if [[ "${absolute_path_output}" == "1" ]]; then
1620 echo -n "${EPREFIX}/usr/bin/${python_interpreter}" 1888 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1621 else 1889 else
1714 if [[ "${EAPI:-0}" == "0" ]]; then 1982 if [[ "${EAPI:-0}" == "0" ]]; then
1715 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1983 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1716 echo "=dev-lang/python-${PYTHON_ABI}*" 1984 echo "=dev-lang/python-${PYTHON_ABI}*"
1717 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1985 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1718 echo "=dev-java/jython-${PYTHON_ABI%-jython}*" 1986 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
1987 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
1988 echo "=dev-python/pypy-${PYTHON_ABI#*-pypy-}*"
1719 fi 1989 fi
1720 else 1990 else
1721 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1991 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1722 echo "dev-lang/python:${PYTHON_ABI}" 1992 echo "dev-lang/python:${PYTHON_ABI}"
1723 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1993 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1724 echo "dev-java/jython:${PYTHON_ABI%-jython}" 1994 echo "dev-java/jython:${PYTHON_ABI%-jython}"
1995 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
1996 echo "dev-python/pypy:${PYTHON_ABI#*-pypy-}"
1725 fi 1997 fi
1726 fi 1998 fi
1727} 1999}
1728 2000
1729# @FUNCTION: python_get_includedir 2001# @FUNCTION: python_get_includedir
1776 2048
1777 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2049 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1778 echo "${prefix}usr/include/python${PYTHON_ABI}" 2050 echo "${prefix}usr/include/python${PYTHON_ABI}"
1779 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2051 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1780 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include" 2052 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
2053 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2054 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/include"
1781 fi 2055 fi
1782} 2056}
1783 2057
1784# @FUNCTION: python_get_libdir 2058# @FUNCTION: python_get_libdir
1785# @USAGE: [-b|--base-path] [-f|--final-ABI] 2059# @USAGE: [-b|--base-path] [-f|--final-ABI]
1786# @DESCRIPTION: 2060# @DESCRIPTION:
1787# Print path to Python library directory. 2061# Print path to Python standard library directory.
1788# If --base-path option is specified, then path not prefixed with "/" is printed. 2062# If --base-path option is specified, then path not prefixed with "/" is printed.
1789# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2063# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1790python_get_libdir() { 2064python_get_libdir() {
1791 _python_check_python_pkg_setup_execution 2065 _python_check_python_pkg_setup_execution
1792 2066
1831 2105
1832 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2106 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1833 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}" 2107 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
1834 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2108 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1835 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib" 2109 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
2110 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2111 die "${FUNCNAME}(): PyPy has multiple standard library directories"
1836 fi 2112 fi
1837} 2113}
1838 2114
1839# @FUNCTION: python_get_sitedir 2115# @FUNCTION: python_get_sitedir
1840# @USAGE: [-b|--base-path] [-f|--final-ABI] 2116# @USAGE: [-b|--base-path] [-f|--final-ABI]
1843# If --base-path option is specified, then path not prefixed with "/" is printed. 2119# If --base-path option is specified, then path not prefixed with "/" is printed.
1844# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2120# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1845python_get_sitedir() { 2121python_get_sitedir() {
1846 _python_check_python_pkg_setup_execution 2122 _python_check_python_pkg_setup_execution
1847 2123
1848 local final_ABI="0" options=() 2124 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1849 2125
1850 while (($#)); do 2126 while (($#)); do
1851 case "$1" in 2127 case "$1" in
1852 -b|--base-path) 2128 -b|--base-path)
1853 options+=("$1") 2129 base_path="1"
1854 ;; 2130 ;;
1855 -f|--final-ABI) 2131 -f|--final-ABI)
1856 final_ABI="1" 2132 final_ABI="1"
1857 options+=("$1")
1858 ;; 2133 ;;
1859 -*) 2134 -*)
1860 die "${FUNCNAME}(): Unrecognized option '$1'" 2135 die "${FUNCNAME}(): Unrecognized option '$1'"
1861 ;; 2136 ;;
1862 *) 2137 *)
1864 ;; 2139 ;;
1865 esac 2140 esac
1866 shift 2141 shift
1867 done 2142 done
1868 2143
2144 if [[ "${base_path}" == "0" ]]; then
2145 prefix="/"
2146 fi
2147
1869 if [[ "${final_ABI}" == "1" ]]; then 2148 if [[ "${final_ABI}" == "1" ]]; then
1870 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2149 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1871 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2150 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1872 fi 2151 fi
2152 PYTHON_ABI="$(PYTHON -f --ABI)"
1873 else 2153 else
1874 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then 2154 if _python_package_supporting_installation_for_multiple_python_abis; then
2155 if ! _python_abi-specific_local_scope; then
1875 die "${FUNCNAME}() should be used in ABI-specific local scope" 2156 die "${FUNCNAME}() should be used in ABI-specific local scope"
1876 fi 2157 fi
2158 else
2159 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1877 fi 2160 fi
2161 fi
1878 2162
1879 echo "$(python_get_libdir "${options[@]}")/site-packages" 2163 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2164 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}/site-packages"
2165 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2166 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib/site-packages"
2167 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2168 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/site-packages"
2169 fi
1880} 2170}
1881 2171
1882# @FUNCTION: python_get_library 2172# @FUNCTION: python_get_library
1883# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option] 2173# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
1884# @DESCRIPTION: 2174# @DESCRIPTION:
1941 else 2231 else
1942 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)" 2232 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
1943 fi 2233 fi
1944 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2234 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1945 die "${FUNCNAME}(): Jython does not have shared library" 2235 die "${FUNCNAME}(): Jython does not have shared library"
2236 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2237 die "${FUNCNAME}(): PyPy does not have shared library"
1946 fi 2238 fi
1947} 2239}
1948 2240
1949# @FUNCTION: python_get_version 2241# @FUNCTION: python_get_version
1950# @USAGE: [-f|--final-ABI] [--full] [--major] [--minor] [--micro] 2242# @USAGE: [-f|--final-ABI] [-l|--language] [--full] [--major] [--minor] [--micro]
1951# @DESCRIPTION: 2243# @DESCRIPTION:
1952# Print Python version. 2244# Print version of Python implementation.
1953# --full, --major, --minor and --micro options cannot be specified simultaneously. 2245# --full, --major, --minor and --micro options cannot be specified simultaneously.
1954# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed. 2246# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
2247# If --language option is specified, then version of Python language is printed.
2248# --language and --full options cannot be specified simultaneously.
2249# --language and --micro options cannot be specified simultaneously.
1955# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2250# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1956python_get_version() { 2251python_get_version() {
1957 _python_check_python_pkg_setup_execution 2252 _python_check_python_pkg_setup_execution
1958 2253
1959 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command 2254 local final_ABI="0" language="0" language_version full="0" major="0" minor="0" micro="0" PYTHON_ABI="${PYTHON_ABI}" python_command
1960 2255
1961 while (($#)); do 2256 while (($#)); do
1962 case "$1" in 2257 case "$1" in
1963 -f|--final-ABI) 2258 -f|--final-ABI)
1964 final_ABI="1" 2259 final_ABI="1"
1965 ;; 2260 ;;
2261 -l|--language)
2262 language="1"
2263 ;;
1966 --full) 2264 --full)
1967 full="1" 2265 full="1"
1968 ;; 2266 ;;
1969 --major) 2267 --major)
1970 major="1" 2268 major="1"
1983 ;; 2281 ;;
1984 esac 2282 esac
1985 shift 2283 shift
1986 done 2284 done
1987 2285
1988 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
1989 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
1990 fi
1991
1992 if [[ "${full}" == "1" ]]; then
1993 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
1994 elif [[ "${major}" == "1" ]]; then
1995 python_command="from sys import version_info; print(version_info[0])"
1996 elif [[ "${minor}" == "1" ]]; then
1997 python_command="from sys import version_info; print(version_info[1])"
1998 elif [[ "${micro}" == "1" ]]; then
1999 python_command="from sys import version_info; print(version_info[2])"
2000 else
2001 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2002 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2003 echo "${PYTHON_ABI}"
2004 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2005 echo "${PYTHON_ABI%-jython}"
2006 fi
2007 return
2008 fi
2009 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2010 fi
2011
2012 if [[ "${final_ABI}" == "1" ]]; then 2286 if [[ "${final_ABI}" == "1" ]]; then
2013 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2287 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2014 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2288 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2015 fi 2289 fi
2016 "$(PYTHON -f)" -c "${python_command}"
2017 else 2290 else
2018 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then 2291 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2019 die "${FUNCNAME}() should be used in ABI-specific local scope" 2292 die "${FUNCNAME}() should be used in ABI-specific local scope"
2020 fi 2293 fi
2294 fi
2295
2296 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
2297 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
2298 fi
2299
2300 if [[ "${language}" == "1" ]]; then
2301 if [[ "${final_ABI}" == "1" ]]; then
2302 PYTHON_ABI="$(PYTHON -f --ABI)"
2303 elif [[ -z "${PYTHON_ABI}" ]]; then
2304 PYTHON_ABI="$(PYTHON --ABI)"
2305 fi
2306 language_version="${PYTHON_ABI%%-*}"
2307 if [[ "${full}" == "1" ]]; then
2308 die "${FUNCNAME}(): '--language' and '--full' options cannot be specified simultaneously"
2309 elif [[ "${major}" == "1" ]]; then
2310 echo "${language_version%.*}"
2311 elif [[ "${minor}" == "1" ]]; then
2312 echo "${language_version#*.}"
2313 elif [[ "${micro}" == "1" ]]; then
2314 die "${FUNCNAME}(): '--language' and '--micro' options cannot be specified simultaneously"
2315 else
2316 echo "${language_version}"
2317 fi
2318 else
2319 if [[ "${full}" == "1" ]]; then
2320 python_command="import sys; print('.'.join(str(x) for x in getattr(sys, 'pypy_version_info', sys.version_info)[:3]))"
2321 elif [[ "${major}" == "1" ]]; then
2322 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[0])"
2323 elif [[ "${minor}" == "1" ]]; then
2324 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[1])"
2325 elif [[ "${micro}" == "1" ]]; then
2326 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[2])"
2327 else
2328 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2329 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2330 echo "${PYTHON_ABI}"
2331 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2332 echo "${PYTHON_ABI%-jython}"
2333 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2334 echo "${PYTHON_ABI#*-pypy-}"
2335 fi
2336 return
2337 fi
2338 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2339 fi
2340
2341 if [[ "${final_ABI}" == "1" ]]; then
2342 "$(PYTHON -f)" -c "${python_command}"
2343 else
2021 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}" 2344 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
2345 fi
2346 fi
2347}
2348
2349# @FUNCTION: python_get_implementation_and_version
2350# @USAGE: [-f|--final-ABI]
2351# @DESCRIPTION:
2352# Print name and version of Python implementation.
2353# If version of Python implementation is not bound to version of Python language, then
2354# version of Python language is additionally printed.
2355# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2356python_get_implementation_and_version() {
2357 _python_check_python_pkg_setup_execution
2358
2359 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
2360
2361 while (($#)); do
2362 case "$1" in
2363 -f|--final-ABI)
2364 final_ABI="1"
2365 ;;
2366 -*)
2367 die "${FUNCNAME}(): Unrecognized option '$1'"
2368 ;;
2369 *)
2370 die "${FUNCNAME}(): Invalid usage"
2371 ;;
2372 esac
2373 shift
2374 done
2375
2376 if [[ "${final_ABI}" == "1" ]]; then
2377 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2378 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2379 fi
2380 PYTHON_ABI="$(PYTHON -f --ABI)"
2381 else
2382 if _python_package_supporting_installation_for_multiple_python_abis; then
2383 if ! _python_abi-specific_local_scope; then
2384 die "${FUNCNAME}() should be used in ABI-specific local scope"
2385 fi
2386 else
2387 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2388 fi
2389 fi
2390
2391 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-[[:alnum:]]+-[[:digit:]]+\.[[:digit:]]+$ ]]; then
2392 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI##*-} (Python ${PYTHON_ABI%%-*})"
2393 else
2394 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI%%-*}"
2022 fi 2395 fi
2023} 2396}
2024 2397
2025# ================================================================================================ 2398# ================================================================================================
2026# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================ 2399# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
2035_python_test_hook() { 2408_python_test_hook() {
2036 if [[ "$#" -ne 1 ]]; then 2409 if [[ "$#" -ne 1 ]]; then
2037 die "${FUNCNAME}() requires 1 argument" 2410 die "${FUNCNAME}() requires 1 argument"
2038 fi 2411 fi
2039 2412
2040 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then 2413 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${_PYTHON_TEST_FUNCTION}_$1_hook")" == "function" ]]; then
2041 "${FUNCNAME[3]}_$1_hook" 2414 "${_PYTHON_TEST_FUNCTION}_$1_hook"
2042 fi 2415 fi
2043} 2416}
2044 2417
2045# @FUNCTION: python_execute_nosetests 2418# @FUNCTION: python_execute_nosetests
2046# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2419# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
2050# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined. 2423# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined.
2051python_execute_nosetests() { 2424python_execute_nosetests() {
2052 _python_check_python_pkg_setup_execution 2425 _python_check_python_pkg_setup_execution
2053 _python_set_color_variables 2426 _python_set_color_variables
2054 2427
2055 local PYTHONPATH_template= separate_build_dirs= 2428 local PYTHONPATH_template separate_build_dirs
2056 2429
2057 while (($#)); do 2430 while (($#)); do
2058 case "$1" in 2431 case "$1" in
2059 -P|--PYTHONPATH) 2432 -P|--PYTHONPATH)
2060 PYTHONPATH_template="$2" 2433 PYTHONPATH_template="$2"
2080 python_test_function() { 2453 python_test_function() {
2081 local evaluated_PYTHONPATH 2454 local evaluated_PYTHONPATH
2082 2455
2083 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2456 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2084 2457
2085 _python_test_hook pre 2458 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook pre
2086 2459
2087 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2460 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2088 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2461 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2089 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2462 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2090 else 2463 else
2091 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2464 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2092 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2465 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2093 fi 2466 fi
2094 2467
2095 _python_test_hook post 2468 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook post
2096 } 2469 }
2097 if _python_package_supporting_installation_for_multiple_python_abis; then 2470 if _python_package_supporting_installation_for_multiple_python_abis; then
2098 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2471 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2099 else 2472 else
2100 if [[ -n "${separate_build_dirs}" ]]; then 2473 if [[ -n "${separate_build_dirs}" ]]; then
2114# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined. 2487# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined.
2115python_execute_py.test() { 2488python_execute_py.test() {
2116 _python_check_python_pkg_setup_execution 2489 _python_check_python_pkg_setup_execution
2117 _python_set_color_variables 2490 _python_set_color_variables
2118 2491
2119 local PYTHONPATH_template= separate_build_dirs= 2492 local PYTHONPATH_template separate_build_dirs
2120 2493
2121 while (($#)); do 2494 while (($#)); do
2122 case "$1" in 2495 case "$1" in
2123 -P|--PYTHONPATH) 2496 -P|--PYTHONPATH)
2124 PYTHONPATH_template="$2" 2497 PYTHONPATH_template="$2"
2144 python_test_function() { 2517 python_test_function() {
2145 local evaluated_PYTHONPATH 2518 local evaluated_PYTHONPATH
2146 2519
2147 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2520 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2148 2521
2149 _python_test_hook pre 2522 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook pre
2150 2523
2151 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2524 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2152 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL} 2525 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
2153 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?" 2526 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
2154 else 2527 else
2155 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL} 2528 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
2156 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?" 2529 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
2157 fi 2530 fi
2158 2531
2159 _python_test_hook post 2532 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook post
2160 } 2533 }
2161 if _python_package_supporting_installation_for_multiple_python_abis; then 2534 if _python_package_supporting_installation_for_multiple_python_abis; then
2162 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2535 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2163 else 2536 else
2164 if [[ -n "${separate_build_dirs}" ]]; then 2537 if [[ -n "${separate_build_dirs}" ]]; then
2178# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined. 2551# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined.
2179python_execute_trial() { 2552python_execute_trial() {
2180 _python_check_python_pkg_setup_execution 2553 _python_check_python_pkg_setup_execution
2181 _python_set_color_variables 2554 _python_set_color_variables
2182 2555
2183 local PYTHONPATH_template= separate_build_dirs= 2556 local PYTHONPATH_template separate_build_dirs
2184 2557
2185 while (($#)); do 2558 while (($#)); do
2186 case "$1" in 2559 case "$1" in
2187 -P|--PYTHONPATH) 2560 -P|--PYTHONPATH)
2188 PYTHONPATH_template="$2" 2561 PYTHONPATH_template="$2"
2208 python_test_function() { 2581 python_test_function() {
2209 local evaluated_PYTHONPATH 2582 local evaluated_PYTHONPATH
2210 2583
2211 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2584 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2212 2585
2213 _python_test_hook pre 2586 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook pre
2214 2587
2215 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2588 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2216 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2589 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2217 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2590 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2218 else 2591 else
2219 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2592 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2220 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2593 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2221 fi 2594 fi
2222 2595
2223 _python_test_hook post 2596 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook post
2224 } 2597 }
2225 if _python_package_supporting_installation_for_multiple_python_abis; then 2598 if _python_package_supporting_installation_for_multiple_python_abis; then
2226 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2599 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2227 else 2600 else
2228 if [[ -n "${separate_build_dirs}" ]]; then 2601 if [[ -n "${separate_build_dirs}" ]]; then
2328 if [[ "${dir}" == "__pycache__" ]]; then 2701 if [[ "${dir}" == "__pycache__" ]]; then
2329 base_module_name="${compiled_file##*/}" 2702 base_module_name="${compiled_file##*/}"
2330 base_module_name="${base_module_name%\$py.class}" 2703 base_module_name="${base_module_name%\$py.class}"
2331 py_file="${compiled_file%__pycache__/*}${base_module_name}.py" 2704 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2332 else 2705 else
2333 py_file="${compiled_file%\$py.class}" 2706 py_file="${compiled_file%\$py.class}.py"
2334 fi 2707 fi
2335 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then 2708 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2336 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue 2709 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2337 else 2710 else
2338 [[ -f "${py_file}" ]] && continue 2711 [[ -f "${py_file}" ]] && continue
2363# Byte-compile specified Python modules. 2736# Byte-compile specified Python modules.
2364# -d, -f, -l, -q and -x options passed to this function are passed to compileall.py. 2737# -d, -f, -l, -q and -x options passed to this function are passed to compileall.py.
2365# 2738#
2366# This function can be used only in pkg_postinst() phase. 2739# This function can be used only in pkg_postinst() phase.
2367python_mod_optimize() { 2740python_mod_optimize() {
2741 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then
2742 die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2743 fi
2744
2368 _python_check_python_pkg_setup_execution 2745 _python_check_python_pkg_setup_execution
2369 _python_initialize_prefix_variables 2746 _python_initialize_prefix_variables
2370 2747
2371 # Check if phase is pkg_postinst().
2372 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2373
2374 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then 2748 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
2375 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs. 2749 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs.
2376 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() 2750 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() stderr stderr_line
2377 2751
2378 if _python_package_supporting_installation_for_multiple_python_abis; then 2752 if _python_package_supporting_installation_for_multiple_python_abis; then
2379 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then 2753 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2380 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called" 2754 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2381 fi 2755 fi
2476 options+=("-q") 2850 options+=("-q")
2477 2851
2478 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 2852 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2479 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then 2853 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
2480 return_code="0" 2854 return_code="0"
2855 stderr=""
2481 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)" 2856 ebegin "Compilation and optimization of Python modules for $(python_get_implementation_and_version)"
2482 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then 2857 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
2483 for dir in "${site_packages_dirs[@]}"; do 2858 for dir in "${site_packages_dirs[@]}"; do
2484 dirs+=("${root}$(python_get_sitedir)/${dir}") 2859 dirs+=("${root}$(python_get_sitedir)/${dir}")
2485 done 2860 done
2486 for dir in "${evaluated_dirs[@]}"; do 2861 for dir in "${evaluated_dirs[@]}"; do
2487 eval "dirs+=(\"\${root}${dir}\")" 2862 eval "dirs+=(\"\${root}${dir}\")"
2488 done 2863 done
2489 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" || return_code="1" 2864 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m compileall "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1"
2490 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2865 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2491 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1" 2866 "$(PYTHON)" -O -m compileall "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
2492 fi 2867 fi
2493 _python_clean_compiled_modules "${dirs[@]}" 2868 _python_clean_compiled_modules "${dirs[@]}"
2494 fi 2869 fi
2495 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then 2870 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
2496 for file in "${site_packages_files[@]}"; do 2871 for file in "${site_packages_files[@]}"; do
2497 files+=("${root}$(python_get_sitedir)/${file}") 2872 files+=("${root}$(python_get_sitedir)/${file}")
2498 done 2873 done
2499 for file in "${evaluated_files[@]}"; do 2874 for file in "${evaluated_files[@]}"; do
2500 eval "files+=(\"\${root}${file}\")" 2875 eval "files+=(\"\${root}${file}\")"
2501 done 2876 done
2502 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" || return_code="1" 2877 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m py_compile "${files[@]}" 2>&1)" || return_code="1"
2503 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2878 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2504 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" &> /dev/null || return_code="1" 2879 "$(PYTHON)" -O -m py_compile "${files[@]}" &> /dev/null || return_code="1"
2505 fi 2880 fi
2506 _python_clean_compiled_modules "${files[@]}" 2881 _python_clean_compiled_modules "${files[@]}"
2507 fi 2882 fi
2508 eend "${return_code}" 2883 eend "${return_code}"
2884 if [[ -n "${stderr}" ]]; then
2885 eerror "Syntax errors / warnings in Python modules for $(python_get_implementation_and_version):" &> /dev/null
2886 while read stderr_line; do
2887 eerror " ${stderr_line}"
2888 done <<< "${stderr}"
2889 fi
2509 fi 2890 fi
2510 unset dirs files 2891 unset dirs files
2511 done 2892 done
2512 2893
2513 if _python_package_supporting_installation_for_multiple_python_abis; then 2894 if _python_package_supporting_installation_for_multiple_python_abis; then
2519 fi 2900 fi
2520 fi 2901 fi
2521 2902
2522 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2903 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
2523 return_code="0" 2904 return_code="0"
2905 stderr=""
2524 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)" 2906 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation_and_version)"
2525 if ((${#other_dirs[@]})); then 2907 if ((${#other_dirs[@]})); then
2526 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 2908 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m compileall "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1"
2527 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2909 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2528 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2910 "$(PYTHON ${PYTHON_ABI})" -O -m compileall "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
2529 fi 2911 fi
2530 _python_clean_compiled_modules "${other_dirs[@]}" 2912 _python_clean_compiled_modules "${other_dirs[@]}"
2531 fi 2913 fi
2532 if ((${#other_files[@]})); then 2914 if ((${#other_files[@]})); then
2533 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 2915 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m py_compile "${other_files[@]}" 2>&1)" || return_code="1"
2534 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2916 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2535 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2917 "$(PYTHON ${PYTHON_ABI})" -O -m py_compile "${other_files[@]}" &> /dev/null || return_code="1"
2536 fi 2918 fi
2537 _python_clean_compiled_modules "${other_files[@]}" 2919 _python_clean_compiled_modules "${other_files[@]}"
2538 fi 2920 fi
2539 eend "${return_code}" 2921 eend "${return_code}"
2922 if [[ -n "${stderr}" ]]; then
2923 eerror "Syntax errors / warnings in Python modules placed outside of site-packages directories for $(python_get_implementation_and_version):" &> /dev/null
2924 while read stderr_line; do
2925 eerror " ${stderr_line}"
2926 done <<< "${stderr}"
2927 fi
2540 fi 2928 fi
2541 else 2929 else
2542 # Deprecated part of python_mod_optimize() 2930 # Deprecated part of python_mod_optimize()
2543 # ewarn 2931 ewarn
2544 # ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation" 2932 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2545 # ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-06-01." 2933 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
2546 # ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax." 2934 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
2547 # ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." 2935 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
2548 # ewarn 2936 ewarn
2549 2937
2550 local myroot mydirs=() myfiles=() myopts=() return_code="0" 2938 local myroot mydirs=() myfiles=() myopts=() return_code="0"
2551 2939
2552 # strip trailing slash 2940 # strip trailing slash
2553 myroot="${EROOT%/}" 2941 myroot="${EROOT%/}"
2622# @DESCRIPTION: 3010# @DESCRIPTION:
2623# Delete orphaned byte-compiled Python modules corresponding to specified Python modules. 3011# Delete orphaned byte-compiled Python modules corresponding to specified Python modules.
2624# 3012#
2625# This function can be used only in pkg_postrm() phase. 3013# This function can be used only in pkg_postrm() phase.
2626python_mod_cleanup() { 3014python_mod_cleanup() {
3015 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then
3016 die "${FUNCNAME}() can be used only in pkg_postrm() phase"
3017 fi
3018
2627 _python_check_python_pkg_setup_execution 3019 _python_check_python_pkg_setup_execution
2628 _python_initialize_prefix_variables 3020 _python_initialize_prefix_variables
2629 3021
2630 local allow_evaluated_non_sitedir_paths="0" dir iterated_PYTHON_ABIS PYTHON_ABI="${PYTHON_ABI}" root search_paths=() sitedir 3022 local allow_evaluated_non_sitedir_paths="0" dir iterated_PYTHON_ABIS PYTHON_ABI="${PYTHON_ABI}" root search_paths=() sitedir
2631
2632 # Check if phase is pkg_postrm().
2633 [[ "${EBUILD_PHASE}" != "postrm" ]] && die "${FUNCNAME}() can be used only in pkg_postrm() phase"
2634 3023
2635 if _python_package_supporting_installation_for_multiple_python_abis; then 3024 if _python_package_supporting_installation_for_multiple_python_abis; then
2636 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then 3025 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2637 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called" 3026 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2638 fi 3027 fi
2702 fi 3091 fi
2703 shift 3092 shift
2704 done 3093 done
2705 else 3094 else
2706 # Deprecated part of python_mod_cleanup() 3095 # Deprecated part of python_mod_cleanup()
2707 # ewarn 3096 ewarn
2708 # ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation" 3097 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2709 # ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-06-01." 3098 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
2710 # ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax." 3099 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
2711 # ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." 3100 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
2712 # ewarn 3101 ewarn
2713 3102
2714 search_paths=("${@#/}") 3103 search_paths=("${@#/}")
2715 search_paths=("${search_paths[@]/#/${root}/}") 3104 search_paths=("${search_paths[@]/#/${root}/}")
2716 fi 3105 fi
2717 3106
2719} 3108}
2720 3109
2721# ================================================================================================ 3110# ================================================================================================
2722# ===================================== DEPRECATED FUNCTIONS ===================================== 3111# ===================================== DEPRECATED FUNCTIONS =====================================
2723# ================================================================================================ 3112# ================================================================================================
2724
2725# Scheduled for deletion on 2011-01-01.
2726python_version() {
2727 eerror "Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables."
2728 die "${FUNCNAME}() is banned"
2729}
2730
2731# Scheduled for deletion on 2011-01-01.
2732python_mod_exists() {
2733 eerror "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()."
2734 die "${FUNCNAME}() is banned"
2735}
2736
2737# Scheduled for deletion on 2011-01-01.
2738python_tkinter_exists() {
2739 eerror "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()."
2740 die "${FUNCNAME}() is banned"
2741}
2742
2743# Scheduled for deletion on 2011-04-01.
2744python_mod_compile() {
2745 eerror "Use python_mod_optimize() instead of ${FUNCNAME}()."
2746 die "${FUNCNAME}() is banned"
2747}

Legend:
Removed from v.1.104  
changed lines
  Added in v.1.139

  ViewVC Help
Powered by ViewVC 1.1.20